<?php
// Pre-Flight check
	$tests=array();
	$errors=0;
	if (isset($_SERVER['REMOTE_USER'])) {
		$tests['Remote User']['state']="good";
		$tests['Remote User']['message']='';
	}
	else {
		$tests['Remote User']['state']="fail";
		$tests['Remote User']['message']='<a href="http://httpd.apache.org/docs/2.2/howto/auth.html">http://httpd.apache.org/docs/2.2/howto/auth.html</a>';
		$errors++;
	}

	if (extension_loaded('mbstring')) {
		$tests['mbstring']['state']="good";
		$tests['mbstring']['message']='';
	}
	else {
		$tests['mbstring']['state']="fail";
		$tests['mbstring']['message']='PHP is missing the <a href="http://php.net/mbstring">mbstring extension</a>';
		$errors++;
	}

	if(extension_loaded('snmp')){
		$tests['snmp']['state']="good";
		$tests['snmp']['message']='';
	}else{
		$tests['snmp']['state']="fail";
		$tests['snmp']['message']='PHP is missing the snmp extension. Please install it.';
	}

	if(extension_loaded('gettext')) {
		$tests['gettext']['state']="good";
		$tests['gettext']['message']='';
	}else{
		$tests['gettext']['state']="fail";
		$tests['gettext']['message']='PHP is missing the <a href="http://php.net/manual/book.gettext.php">Gettext extension</a>. Please install it.';
	}

	$tests['pdo']['message']='';
	if (extension_loaded('PDO')) {
		$tests['pdo']['state']="good";
		if (count(PDO::getAvailableDrivers())>0) {
			$tests['pdodrivers']['message']='Available drivers: '.implode(", ",PDO::getAvailableDrivers());
			$tests['pdodrivers']['state']="good";
		}
		else {
			$tests['pdodrivers']['message']='Available drivers: none';
			$tests['pdodrivers']['state']="fail";
			$errors++;
		}
	}
	else {
		$tests['pdo']['state']="fail";
		$tests['pdo']['message']='openDCIM requires the <a href="http://php.net/manual/pdo.installation.php">PDO extention</a> and you do not appear to have it loaded';
		$tests['pdodrivers']['state']="fail";
		$tests['pdodrivers']['message']='No PDO drivers have been detected';
		$errors++;
	}

	if (function_exists('json_encode')) {
		$tests['json']['state']="good";
		$tests['json']['message']='PHP json module detected';
	}
	else {
		$tests['json']['state']="fail";
		$tests['json']['message']='PHP is missing the <a href="http://php.net/manual/book.json.php">JavaScript Object Notation (JSON) extension</a>.  Please install it.';
		$errors++;
	}

	echo '<!doctype html><html><head><title>openDCIM :: pre-flight environment sanity check</title><script type="text/javascript" src="scripts/jquery.min.js"></script><script type="text/javascript" src="scripts/jquery-ui.min.js"></script><script type="text/javascript">$(document).ready(function(){$("tr").each(function(){if($(this).find("td:last-child").text()=="fail"){$(this).addClass("fail");}});});</script><style type="text/css">table{width:80%;border-collapse:collapse;border:3px solid black;}th{text-align:left;text-transform:uppercase;border-right: 1px solid black;}th,td{padding:5px;}tr:nth-child(even){background-color:#d1e1f1;}td:last-child{text-align:center;text-transform:uppercase;border:2px solid;background-color:green;}.fail td:last-child{font-weight: bold;background-color: red;}</style></head><body><h2>Pre-flight environment checks</h2><table>';
	foreach($tests as $test => $text){
		print "<tr><th>$test</th><td>{$text['message']}</td><td>{$text['state']}</td></tr>";
	}
	echo '<tr><th>javascript</th><td>Javascript is used heavily for data validation and a more polished user experience.</td><td><script>document.write("good")</script><noscript>fail</noscript></td></tr>
		</table>
	<p>If you are seeing this page then you must correct any issues shown above before the installer will continue.</p>


<script type="text/javascript">
if (typeof jQuery == "undefined") {
	alert("jQuery is not loaded");
	window.location.assign("http://opendcim.org/wiki/index.php?title=Errors:Operational");
}else{
	var tr=$("<tr>");
	$("<th>").text("jQuery").appendTo(tr);
	$("<td>").text("jQuery is used extensively throughout openDCIM for user interface elements").appendTo(tr);
	$("<td>").text("good").appendTo(tr);
	$("table").append(tr);
}
if (typeof jQuery.ui == "undefined") {
	alert("jQueryUI is not loaded");
	window.location.assign("http://opendcim.org/wiki/index.php?title=Errors:Operational");
}else{
	var tr=$("<tr>");
	$("<th>").text("jQuery-ui").appendTo(tr);
	$("<td>").text("jQuery-ui is an extension to jQuery that is used for things like autocomplete, modal dialogs, etc").appendTo(tr);
	$("<td>").text("good").appendTo(tr);
	$("table").append(tr);
}
</script>


	</body></html>';
	exit;
?>
